package cn.ibizlab.businesscentral.core.product.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.product.domain.ProductSalesLiterature;
import cn.ibizlab.businesscentral.core.product.filter.ProductSalesLiteratureSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[ProductSalesLiterature] 服务对象接口
 */
public interface IProductSalesLiteratureService extends IService<ProductSalesLiterature>{

    boolean create(ProductSalesLiterature et) ;
    void createBatch(List<ProductSalesLiterature> list) ;
    boolean update(ProductSalesLiterature et) ;
    void updateBatch(List<ProductSalesLiterature> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    ProductSalesLiterature get(String key) ;
    ProductSalesLiterature getDraft(ProductSalesLiterature et) ;
    boolean checkKey(ProductSalesLiterature et) ;
    boolean save(ProductSalesLiterature et) ;
    void saveBatch(List<ProductSalesLiterature> list) ;
    Page<ProductSalesLiterature> searchDefault(ProductSalesLiteratureSearchContext context) ;
    List<ProductSalesLiterature> selectByEntityid(String productid) ;
    void removeByEntityid(String productid) ;
    List<ProductSalesLiterature> selectByEntity2id(String salesliteratureid) ;
    void removeByEntity2id(String salesliteratureid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<ProductSalesLiterature> getProductsalesliteratureByIds(List<String> ids) ;
    List<ProductSalesLiterature> getProductsalesliteratureByEntities(List<ProductSalesLiterature> entities) ;
}


